config/routes.rb
Rails.application.routes.draw do


  get 'logout' => 'sessions#logout'
  get 'login' => 'sessions#login'
  post 'login_process' => 'sessions#login_process'
  get 'welcome_user' => 'sessions#welcome_user'
  get 'student_rank' => 'students#student_rank'

  
  resources :student_marks
  resources :subjects
  resources :students
  resources :users
  resources :roles

  root 'sessions#login'

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/student.rb
class Student < ApplicationRecord
end

app/controllers/students_controller.rb
class StudentsController < ApplicationController
  before_action :set_student, only: [:show, :edit, :update, :destroy]

  # GET /students
  # GET /students.json
  def index
    @students = Student.all
  end

  # GET /students/1
  # GET /students/1.json
  def show
  end

  def student_rank
    @students_rank = Student.all
  end

  # GET /students/new
  def new
    @student = Student.new
  end

  # GET /students/1/edit
  def edit
  end

  # POST /students
  # POST /students.json
  def create
    @student = Student.new(student_params)

    respond_to do |format|
      if @student.save
        format.html { redirect_to students_url, notice: 'Student was successfully created.' }
        format.json { render :show, status: :created, location: @student }
      else
        format.html { render :new }
        format.json { render json: @student.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /students/1
  # PATCH/PUT /students/1.json
  def update
    respond_to do |format|
      if @student.update(student_params)
        format.html { redirect_to students_url, notice: 'Student was successfully updated.' }
        format.json { render :show, status: :ok, location: @student }
      else
        format.html { render :edit }
        format.json { render json: @student.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /students/1
  # DELETE /students/1.json
  def destroy
    @student.destroy
    respond_to do |format|
      format.html { redirect_to students_url, notice: 'Student was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_student
      @student = Student.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def student_params
      params.require(:student).permit(:stud_name, :stud_dob, :age)
    end
end

app/helpers/students_helper.rb
module StudentsHelper
end

app/views/students/_form.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">

<%= form_with(model: student, local: true) do |form| %>
  <% if student.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(student.errors.count, "error") %> prohibited this student from being saved:</h2>

      <ul>
      <% student.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
  <div class="container">
    <div class="form-group row">
      <div class="col-md-5">
        <%= form.label :stud_name, class: "col-form-label" %>
        <%= form.text_field :stud_name, id: :stud_stud_name, class: "form-control", required: true %>
      </div>

      <div class="col-md-5">
        <%= form.label :stud_dob, class: "col-form-label" %>
        <%= form.date_field :stud_dob, id: :stud_stud_dob, class: "form-control", required: true %>
      </div>

      <div class="col-md-5">
        <%= form.label :age, class: "col-form-label" %>
        <%= form.text_field :age, id: :age, class: "form-control", required: true %>
      </div>
    </div>

    <div class="actions col-md-12 mt-4">
      <%= form.submit "Submit", class:"btn btn-primary float-right" %>
      <%= link_to "Cancel", students_path, class: "btn btn-warning float-right mr-3" %>
    </div>
  </div>
<% end %>

app/views/students/edit.html.erb
<h1>Editing Student</h1>

<%= render 'form', student: @student %>

<%#= link_to 'Show', @student, class: "btn btn-info float-right mr-3" %> 

app/views/students/index.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"> </script>

<br>
<div style="margin-top: 50px" class="row page-titles">
  <div class="col-md-5 align-self-center">
    <h3 class="text-primary">Students</h3>
  </div>
</div>

<div class="container">
  <div class="card top">
    <div class="row">
      <div class="col-md-1 pull-right">
        <%= link_to 'New', new_student_path , class: "btn btn-info float-right mr-3" %> 
      </div>
      <div class="col-md-1 pull-right">
        <%= link_to 'Back', welcome_user_path , class: "btn btn-warning float-right mr-3" %>
      </div>
    </div>
  </div>
</div>
<br>

<table id="student_list">
  <thead>
    <tr>
      <th>Studend Name</th>
      <th>DOB</th>
      <th>Age</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @students.each do |student| %>
      <tr>
        <td><%= student.stud_name %></td>
        <td><%= student.stud_dob.to_date %></td>
        <td><%= student.age %></td>
        <td><%= link_to "<i class='fa fa-eye' title='Student'></i>".html_safe, student %></td>
        <td><%= link_to "<i class='fa fa-pencil' title='Edit Student'></i>".html_safe, edit_student_path(student) %></td>
        <td><%= link_to "<i class='fa fa-trash' title='Delete Student'></i>".html_safe, student, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>


<script type="text/javascript">
  $(document).ready(function(){
    $('#student_list').dataTable();
  });
</script>

app/views/students/new.html.erb
<h1>New Student</h1>

<%= render 'form', student: @student %>

app/views/students/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Stud name:</strong>
  <%= @student.stud_name %>
</p>

<p>
  <strong>Stud dob:</strong>
  <%= @student.stud_dob %>
</p>

<p>
  <strong>Age:</strong>
  <%= @student.age %>
</p>

<%= link_to 'Edit', edit_student_path(@student), class: "btn btn-danger float-right mr-3" %> 
<%= link_to "Back", students_path, class: "btn btn-warning float-right mr-3" %>

app/views/students/student_rank.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"> </script>

<br>
<div style="margin-top: 50px" class="row page-titles">
  <div class="col-md-5 align-self-center">
    <h3 class="text-primary">Student's Rank</h3>
  </div>
</div>

<div class="container">
  <div class="card top">
    <div class="row">
      <div class="col-md-1 pull-right">
        <%= link_to 'Back', welcome_user_path , class: "btn btn-warning float-right mr-3" %>
      </div>
    </div>
  </div>
</div>
<br>

<table id="students_rank">
  <thead>
    <tr>
      <th>Student Name</th>
      <th>Total Mark</th>
      <th>Rank</th>
    </tr>
  </thead>

  <tbody>
    <% @students_rank.each do |student_rank| %>
      <tr>
        <td><%= student_rank.stud_name %></td>
        <td><%= student_rank.total_mark %></td>
        <td><%= student_rank.rank %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>


<script type="text/javascript">
  $(document).ready(function(){
    $('#students_rank').dataTable();
  });
</script>